/* The RCS version of hdfgen.pl used to create this file is: */
/* $Id: hdfgen.pl,v 1.49 1999/11/04 17:17:13 asc Exp  */

/* The include file used to create this file is: */
/* $Id:  */

#include "mag_level2_data_1sec.h"
#include "df.h"

int32 vgrp_id_mag_level2_data_1sec;
static int32 vdata_id_mag_level2_data_1sec;

  /* 1282 is the size of mag_level2_data_1sec.h + 1 added line */
char Vgrp_descrp_MAG_data_1sec[1282];

/****----  init create function  ----****/

int32 init_cr_mag_level2_data_1sec(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{
  int32 retval=0;
  int32 vgrp_ref_w;
  int32 ann_id_w;
  int32 wr_Vgrp_desc_mag_level2_data_1sec();

  void print_mag_level2_data_1sec_error();

  /*         Setup a Vgroup         */
  if ((vgrp_id_mag_level2_data_1sec = Vattach(hdf_fp, -1, "w"))==FAIL) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> Vattach: Couldn't create Vgroup");
    retval = -1;
  }
  Vsetname(vgrp_id_mag_level2_data_1sec, "VG_MAG_data_1sec"); 
  Vsetclass(vgrp_id_mag_level2_data_1sec, "VG_MAG_LEVEL2_DATA_1SEC");


  /*      Get the Vgroup reference     */
  if ((vgrp_ref_w = Vfind(hdf_fp, "VG_MAG_data_1sec" )) ==FAIL) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> Vfind: Couldn't get Vgrp reference");
    retval = -1;
  }
  /*      Add a description to the Vgroup      */
  wr_Vgrp_desc_mag_level2_data_1sec(Vgrp_descrp_MAG_data_1sec);

  if ((ann_id_w = ANcreate(an_id, DFTAG_VG, vgrp_ref_w, AN_DATA_DESC)) ==FAIL) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> ANcreate: Can't create Vgrp description");
    retval = -1;
  }
  if ((ANwriteann(ann_id_w, Vgrp_descrp_MAG_data_1sec, sizeof(Vgrp_descrp_MAG_data_1sec))) ==FAIL) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> ANwriteann: Can't write Vgrp description");
    retval = -1;
  }
  ANendaccess(ann_id_w);

  /*        Setup a Vdata        */
  if ((vdata_id_mag_level2_data_1sec = VSattach(hdf_fp, -1, "w")) ==FAIL) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSattach: Couldn't attach to Vdata");
    retval = -1;
  }
  VSsetname(vdata_id_mag_level2_data_1sec, "MAG_data_1sec");
  VSsetclass(vdata_id_mag_level2_data_1sec, classname);

  /*       Insert the Vdata into the Vgroup       */
  if ((Vinsert(vgrp_id_mag_level2_data_1sec, vdata_id_mag_level2_data_1sec)) ==FAIL) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> Vinsert: Couldn't insert Vdata into Vgroup");
    retval = -1;
  }

  /*    Define the fields in the Vdata    */
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "year", DFNT_INT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define year");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "day", DFNT_INT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define day");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "hr", DFNT_INT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define hr");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "min", DFNT_INT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define min");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "sec", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define sec");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "fp_year", DFNT_FLOAT64, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define fp_year");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "fp_doy", DFNT_FLOAT64, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define fp_doy");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "ACEepoch", DFNT_FLOAT64, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define ACEepoch");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "SCclock", DFNT_UINT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define SCclock");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Br", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Br");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bt", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bt");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bn", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bn");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bmag", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bmag");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Delta", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Delta");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Lambda", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Lambda");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bgse_x", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bgse_x");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bgse_y", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bgse_y");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bgse_z", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bgse_z");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bgsm_x", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bgsm_x");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bgsm_y", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bgsm_y");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Bgsm_z", DFNT_FLOAT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Bgsm_z");
    retval = -1;
  }
  if (VSfdefine(vdata_id_mag_level2_data_1sec, "Quality", DFNT_INT32, (1) )) {
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSfdefine: Couldn't define Quality");
    retval = -1;
  }

  if (VSsetfields(vdata_id_mag_level2_data_1sec,"year, day, hr, min, sec, fp_year, fp_doy, ACEepoch, SCclock, Br, Bt, Bn, Bmag, Delta, Lambda, Bgse_x, Bgse_y, Bgse_z, Bgsm_x, Bgsm_y, Bgsm_z, Quality")){
    print_mag_level2_data_1sec_error("init_cr_mag_level2_data_1sec -> VSsetfields: Couldn't set fields");
    retval = -1;
  }

  return(retval);
}

/* Included for backwards compatibility */

int32 init_wr_mag_level2_data_1sec(int32 hdf_fp, int32 sd_id, int32 an_id, char *classname)
{ return( init_cr_mag_level2_data_1sec(hdf_fp, sd_id, an_id, classname) ); }

/******---- write function ----******/

int32 write_mag_level2_data_1sec(struct MAG_data_1sec MAG_data_1sec_struc, int32 recnum)
{
  int32 retval = 0;
  uint8 *odata;

void print_mag_level2_data_1sec_error();
void pack_mag_level2_data_1sec();

  odata = (uint8 *) malloc(sizeof(struct MAG_data_1sec));
  pack_mag_level2_data_1sec(odata, &MAG_data_1sec_struc);

  if(recnum!=-1) {
	if(VSseek(vdata_id_mag_level2_data_1sec, recnum)==-1) {
		print_mag_level2_data_1sec_error("write_mag_level2_data_1sec -> VSseek: error.");
		retval = -1;
	}
  }
  if(VSwrite(vdata_id_mag_level2_data_1sec, (uint8 *)odata, 1, FULL_INTERLACE) == -1)
    print_mag_level2_data_1sec_error("write_mag_level2_data_1sec -> VSwrite: Couldn't write data.");

  memset(&MAG_data_1sec_struc, 0, sizeof(struct MAG_data_1sec));
  free(odata);
  return(retval);
}

/*----   close write function    ----*/

void close_wr_mag_level2_data_1sec()
{
  VSdetach(vdata_id_mag_level2_data_1sec);
  Vdetach(vgrp_id_mag_level2_data_1sec);
}

/*----     init access function    ----*/

int32 init_acc_mag_level2_data_1sec(int32 hdf_fp, int32 sd_id, char *access_mode)
{
  int32 vdata_ref;
  int32 num_rec;

  void print_mag_level2_data_1sec_error();


  if ((vdata_ref = VSfind(hdf_fp, "MAG_data_1sec")) <= 0 ) {
    print_mag_level2_data_1sec_error("init_acc_mag_level2_data_1sec -> VSfind: Found no vdata of specified type.");
    return(0);
  }
  if ((vdata_id_mag_level2_data_1sec = VSattach(hdf_fp, vdata_ref, access_mode)) ==FAIL) {
    print_mag_level2_data_1sec_error("init_acc_mag_level2_data_1sec -> VSattach: Couldn't attach to hdf file.");
    return(-1);
  }

  VSinquire(vdata_id_mag_level2_data_1sec, &num_rec, NULL, NULL, NULL, NULL);
  if (num_rec == 0) { return(0); }


  if (VSsetfields(vdata_id_mag_level2_data_1sec,"year, day, hr, min, sec, fp_year, fp_doy, ACEepoch, SCclock, Br, Bt, Bn, Bmag, Delta, Lambda, Bgse_x, Bgse_y, Bgse_z, Bgsm_x, Bgsm_y, Bgsm_z, Quality")) {
      print_mag_level2_data_1sec_error("init_acc_mag_level2_data_1sec -> VSsetfields: Unable to set fields.");
      return(-1);
  }
  return(num_rec);
}

/* Included for backwards compatability */

int32 init_rd_mag_level2_data_1sec(int32 hdf_fp, int32 sd_id, char *access_mode)
{ return ( init_acc_mag_level2_data_1sec(hdf_fp, sd_id, access_mode) ); }

/******---- read function ----******/

int32 read_mag_level2_data_1sec(struct MAG_data_1sec *MAG_data_1sec_struc, int32 recnum_rd)
{
int32 maxrec;
static int32 last_recnum = -1;
int32 retval = 0;
uint8 *odata;

void print_mag_level2_data_1sec_error();
void unpack_mag_level2_data_1sec();

  if(recnum_rd==-1) recnum_rd=last_recnum+1;

  odata = (uint8 *) malloc(sizeof(struct MAG_data_1sec));
  VSinquire(vdata_id_mag_level2_data_1sec, &maxrec, NULL, NULL, NULL, NULL);
  if (recnum_rd >= maxrec) return(-1);
  if (recnum_rd != last_recnum+1)
      if (VSseek(vdata_id_mag_level2_data_1sec, recnum_rd)==FAIL) {
          print_mag_level2_data_1sec_error("read_mag_level2_data_1sec -> VSseek unsuccessful");
          retval = -1;
    }
  last_recnum = recnum_rd;

  if(VSread(vdata_id_mag_level2_data_1sec, (uint8 *)odata, 1, FULL_INTERLACE) ==FAIL) {
    print_mag_level2_data_1sec_error("read_mag_level2_data_1sec -> VSread: Couldn't read data.");
    retval = -1;
  }
  unpack_mag_level2_data_1sec(odata, MAG_data_1sec_struc);
  free(odata);
  return(retval);
}

/*----   close read function    ----*/

void close_rd_mag_level2_data_1sec()
{
  VSdetach(vdata_id_mag_level2_data_1sec);
}

/*----  Read V group description, function    ----*/
void rd_Vgrp_desc_mag_level2_data_1sec(int32 hdf_fp, int32 an_id)
{
  int32 ann_id_r;
  int32 num_ann;
  int32 *ann_list;
  int32 vgrp_ref_r;

void print_mag_level2_data_1sec_error();

  /*      Get the Vgroup reference     */
  if ((vgrp_ref_r = Vfind(hdf_fp, "VG_MAG_data_1sec" )) ==FAIL)
    print_mag_level2_data_1sec_error("rd_Vgrp_mag_level2_data_1sec -> Vfind: Couldn't get Vgrp reference.");

  if ((num_ann = ANnumann(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r)) ==FAIL)
    print_mag_level2_data_1sec_error("rd_Vgrp_mag_level2_data_1sec -> ANnumann: Couldn't get number of annotations.");

    ann_list = HDmalloc(num_ann * sizeof(int32));
  if ((num_ann = ANannlist(an_id, AN_DATA_DESC, DFTAG_VG, vgrp_ref_r, ann_list)) ==FAIL)
    print_mag_level2_data_1sec_error("rd_Vgrp_mag_level2_data_1sec -> ANannlist: Couldn't");

  if ((ann_id_r = ANselect(an_id, (num_ann-1), AN_DATA_DESC)) ==FAIL)
    print_mag_level2_data_1sec_error("rd_Vgrp_mag_level2_data_1sec -> ANselect: Couldn't");

  if (ANreadann(ann_id_r, Vgrp_descrp_MAG_data_1sec, HDstrlen(Vgrp_descrp_MAG_data_1sec)) ==FAIL)
    print_mag_level2_data_1sec_error("rd_Vgrp_mag_level2_data_1sec -> ANreadann: Couldn't");

  printf("AN: %s\n", Vgrp_descrp_MAG_data_1sec);
  ANendaccess(ann_id_r);
  ANend(an_id);
}

/*----   error function    ----*/

void print_mag_level2_data_1sec_error(int8 *mess)
{
  fprintf(stderr,"\nERROR in  hdf_mag_level2_data_1sec.c -> %s\n", mess);
  HEprint(stderr, 0);
}

/*----   pack function    ----*/

void pack_mag_level2_data_1sec(uint8 *data, struct MAG_data_1sec *MAG_data_1sec_ptr)
{
int32 ptr=0;

   memcpy(data+ptr, &MAG_data_1sec_ptr->year, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->day, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->hr, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->min, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->sec, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->fp_year, ((8)*(1)) );
   ptr+= ((8)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->fp_doy, ((8)*(1)) );
   ptr+= ((8)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->ACEepoch, ((8)*(1)) );
   ptr+= ((8)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->SCclock, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Br, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bt, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bn, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bmag, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Delta, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Lambda, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bgse_x, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bgse_y, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bgse_z, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bgsm_x, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bgsm_y, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Bgsm_z, ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(data+ptr, &MAG_data_1sec_ptr->Quality, ((4)*(1)) );
   ptr+= ((4)*(1));
}

/*----   unpack function    ----*/

void unpack_mag_level2_data_1sec(uint8 *data, struct MAG_data_1sec *MAG_data_1sec_ptr)
{
int32 ptr=0;

   memcpy(&MAG_data_1sec_ptr->year, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->day, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->hr, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->min, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->sec, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->fp_year, data+ptr,  ((8)*(1)) );
   ptr+= ((8)*(1));
   memcpy(&MAG_data_1sec_ptr->fp_doy, data+ptr,  ((8)*(1)) );
   ptr+= ((8)*(1));
   memcpy(&MAG_data_1sec_ptr->ACEepoch, data+ptr,  ((8)*(1)) );
   ptr+= ((8)*(1));
   memcpy(&MAG_data_1sec_ptr->SCclock, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Br, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bt, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bn, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bmag, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Delta, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Lambda, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bgse_x, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bgse_y, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bgse_z, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bgsm_x, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bgsm_y, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Bgsm_z, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
   memcpy(&MAG_data_1sec_ptr->Quality, data+ptr,  ((4)*(1)) );
   ptr+= ((4)*(1));
}
int32 get_vgrp_id_mag_level2_data_1sec() {return(vgrp_id_mag_level2_data_1sec);}

/*----   V group description function    ----*/

int32 wr_Vgrp_desc_mag_level2_data_1sec(char *wr_strval)
{
  strcpy(wr_strval, "The file 'mag_level2_data_1sec.h' is shown below, it was used to create the data in the Vgroup named 'VG_MAG_data_1sec'.\n\n");
  strcat(wr_strval,"/* Id: $ */\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"#include \"hdfi.h\"\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"struct MAG_data_1sec {\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"  /* UT time at the start of the periods */\n");
  strcat(wr_strval,"  int32   year;                         /* integer year */\n");
  strcat(wr_strval,"  int32   day;                          /* integer day of year */\n");
  strcat(wr_strval,"  int32   hr;                           /* hour of day */\n");
  strcat(wr_strval,"  int32   min;                          /* min of hour */\n");
  strcat(wr_strval,"  float32 sec;                          /* seconds */\n");
  strcat(wr_strval,"  float64 fp_year;                      /* floating point year */\n");
  strcat(wr_strval,"  float64 fp_doy;                       /* floating point Day of YearDOY */ \n");
  strcat(wr_strval,"  float64 ACEepoch;                     /* UT time in sec since 1/1/96 */\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"  /* ACE frame count */\n");
  strcat(wr_strval,"  uint32 SCclock;\n");
  strcat(wr_strval,"      \n");
  strcat(wr_strval,"  /* mag average data */\n");
  strcat(wr_strval,"  float32 Br;\n");
  strcat(wr_strval,"  float32 Bt;\n");
  strcat(wr_strval,"  float32 Bn;\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"  float32 Bmag;\n");
  strcat(wr_strval,"  float32 Delta;\n");
  strcat(wr_strval,"  float32 Lambda;\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"  float32 Bgse_x;\n");
  strcat(wr_strval,"  float32 Bgse_y;\n");
  strcat(wr_strval,"  float32 Bgse_z;\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"  float32 Bgsm_x;\n");
  strcat(wr_strval,"  float32 Bgsm_y;\n");
  strcat(wr_strval,"  float32 Bgsm_z;\n");
  strcat(wr_strval,"\n");
  strcat(wr_strval,"  /* data quality for period */\n");
  strcat(wr_strval,"  int32  Quality;                      /* =0 Normal; */\n");
  strcat(wr_strval,"                                       /* =1 Maneuver & Relaxation*/\n");
  strcat(wr_strval,"				       /* =2 Bad data */\n");
  strcat(wr_strval,"};\n");
  return(0);
}
